package de.uni_leipzig.asv.unsupos;

/**
 * This class implements an ordered pair of two integer numbers. It can also be used as key data type for a
 * <code>HashMap</code> for example. 
 * 
 * @author Andreas Klaus
 */
public class IntegerPair {
  
	/**
	 * Creates a <code>IntegerPair</code> (<code>0</code>, <code>0</code>).
	 */
	public IntegerPair() {
		e1 = new Integer(0);
		e2 = new Integer(0); }
  
	/**
	 * Creates a new <code>IntegerPair</code> (<code>a</code>, <code>b</code>). 
	 * @param a the first number of the integer pair.
	 * @param b the second number of the integer pair.
	 */
	public IntegerPair(int a, int b) {
		e1 = new Integer(a);
		e2 = new Integer(b); }
  
  /**
   * Indicates whether some other object is "equal to" this one.
   * 
   * @return <code>true</code> if the object is equal to object <code>o</code>, <code>false</code> otherwise. 
   */
  public boolean equals(Object o) {
	  if (this == o) {
		  return true;  }
	  if ((o == null) || (getClass() != o.getClass())) {
		  return false; }
	  IntegerPair p = (IntegerPair) o;
	  return (e1.equals(p.e1) && e2.equals(p.e2)); }
  
  /**
   * This class returns a hash code value for the integer pair.
   * 
   * @return a hash code value for the integer pair. 
   */
  public int hashCode() {
	  String p = e1 + "-" + e2;
	  return p.hashCode(); }
  
  /**
   * The first number of the integer pair.
   */
  public Integer e1;
  
  /**
   * The second number of the integer pair.
   */
  public Integer e2;
}
