package combineDifferentDocs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Vector;

import javax.swing.text.AbstractDocument.Content;

import iitb.CRF.Feature;
import iitb.CRF.FeatureGenCache;
import iitb.CRF.FeatureGenerator;
import iitb.MaxentClassifier.DataRecord;
import iitb.MaxentClassifier.DataSet;
import iitb.MaxentClassifier.MaxentClassifier;
import iitb.Utils.Options;

public class TestCRF {
	
	public static void main(String[] args) throws Exception {
		
		File trainFile = new File("c:/master/crftrainingfile.txt");
		
		FileReader fr = new FileReader(trainFile);
		BufferedReader br = new BufferedReader(fr);
		
		Vector<DataRecord> recs = new Vector();
		ArrayList<String> terms = new ArrayList<>();
		ArrayList<String> posTags = new ArrayList<>();
		ArrayList<String> nerTags = new ArrayList<>();
		ArrayList<String> significanceTag = new ArrayList<>();
		int lineCount = 0;
		while(br.ready()){
			lineCount++;
//			System.out.println(lineCount);
			
			int index = 0;
			String content = br.readLine();
			String saveString = content;
			String tempString = "";
			while(content.charAt(index)!='\t'){
				tempString+= content.charAt(index);
				index++;
			}
			index+=2;
			tempString.toLowerCase();
			if(!terms.contains(tempString)){
				terms.add(tempString);
			}
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(content.charAt(index)!='\t'){
				
				tempString+= content.charAt(index);
				index++;
			}
			if(!posTags.contains(tempString)){
				posTags.add(tempString);
			}
			index+=2;
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(content.charAt(index)!='\t'){
				tempString += content.charAt(index);
				index++;
			}
			if(!nerTags.contains(tempString)){
				nerTags.add(tempString);
				System.out.println(saveString);
			}
			index+=2;
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(index!=content.length()){
				tempString += content.charAt(index);
				index++;
				
			}
			if(!significanceTag.contains(tempString)){
				significanceTag.add(tempString);
			}
			
		}
//		System.out.println(terms.size());
//		System.out.println(posTags.size());
//		System.out.println(nerTags.size());
//		System.out.println(significanceTag.size());
//		for(int i = 0; i<terms.size();i++){
//			System.out.println(terms.get(i));
//		}
		BufferedReader br2 = new BufferedReader(new FileReader(trainFile));
		while(br2.ready()){
			DataRecord dr = new DataRecord(4);
			
			String content = br2.readLine();
			int index = 0;
			int col = 0;
			String saveString = content;
			String tempString = "";
			while(content.charAt(index)!='\t'){
				tempString+= content.charAt(index);
				index++;
			}
			index+=2;
			tempString.toLowerCase();
			dr.setColumn(col, (float)terms.indexOf(tempString)/terms.size());
			col++;
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(content.charAt(index)!='\t'){
				
				tempString+= content.charAt(index);
				index++;
			}
			dr.setColumn(col, (float)posTags.indexOf(tempString)/posTags.size());
			col++;
			index+=2;
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(content.charAt(index)!='\t'){
				tempString += content.charAt(index);
				index++;
			}
			dr.setColumn(col, (float)nerTags.indexOf(tempString)/nerTags.size());
			col++;
			index+=2;
			content = content.substring(index);
			index = 0;
			tempString = "";
			while(index!=content.length()){
				tempString += content.charAt(index);
				index++;
				
			}
			dr.setColumn(col, (float) significanceTag.indexOf(tempString)/significanceTag.size());
			
			recs.add(dr);
		}
		
		
		System.out.println(recs.size());
		
		DataSet ds = new DataSet(recs);
		
		Options options = new Options();
		options.setProperty("numColumns = 4", "");
		MaxentClassifier mc = new MaxentClassifier(options);
		
		mc.train(recs);
		
		
	}

}
