package crf;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import newsProcessor.News;

public class PreProcess extends Thread {
	
	private News currentNews;
	private String currentName;
	
	public String getCurrentName() {
		return currentName;
	}

	public void setCurrentName(String currentName) {
		this.currentName = currentName;
	}

	public void setCurrentNews(News currentNews) {
		this.currentNews = currentNews;
	}

	public News getCurrentNews() {
		return currentNews;
	}

	public PreProcess(News news, String name){
		
		setCurrentName(name);
		setCurrentNews(news);
		
		
	}
	
	public static void fromNewsToTextFiles() throws ClassNotFoundException, IOException{
		File makeDir = new File("c:/master/newsTextFiles/");
		if(!makeDir.exists()){
			makeDir.mkdir();
		}
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
		File dir = new File("c:/master/processednewsbystock/");
		File[] dirList = dir.listFiles();
		for(int i = 0;i<dirList.length;i++){
			File[] newsList = dirList[i].listFiles();
			for(int j = 0; j<newsList.length;j++){
//				if(!newsList[j].getName().equals("263052")){
//					
//					continue;
//				}
				FileInputStream fis = new FileInputStream(newsList[j]);
				BufferedInputStream bis = new BufferedInputStream(fis);
				ObjectInputStream ois = new ObjectInputStream(bis);
				Thread t = new PreProcess((News)ois.readObject(), newsList[j].getName());
				exService.submit(t);
			}
			
		}
		exService.shutdown();
		
		
	}
	public void run(){
		String title = currentNews.getTitle() + "\n";
		String message = currentNews.getMessage();
		String finalMessage = "";
//		System.out.println(message);
		int wordCount = 0;
		int prevCount = 0;
		for (int i = 0; i < message.length();i++){
			if (message.charAt(i) == ' '){
				wordCount++;
			}
			
			if (wordCount == 15){
				finalMessage+="\n"+message.substring(prevCount,i);
				prevCount= i;
				wordCount = 0;
			}
			
		}
		finalMessage+="\n"+ message.substring(prevCount);
//		System.out.println(finalMessage);
		message = finalMessage.replace("&#058;", ":");
		message = message.replace("&#036;", "$");
		message = message.replace("&#009;", "\t");
		message = message.replace("&#037;", "%");
		message = message.replace("&#043;", "+");
		message = message.replace("&#039;", "'");
		message = message.replace("&amp;", "&");
		message = message.replace("&#059;", ";");
		message = message.replace("&#058;", ":");
		message = message.replace("&#035;", ":");
		message = message.replace("&quot;","\"");
		message = message.replace("&#064;","\n");
		message = message.replace("&#063;", "?");
		message = message.replace("&#061;", "=");
		message = message.replace("&#123;", "{");
		message = message.replace("&#091;", "[");
		message = message.replace("&#093;", "#");
		message = message.replace("&#042;", "*");
		message = message.replace("&#124;", "|");
		message = message.replace("&#096","`");
		
		title = title.replace("&#036;", "$");
		title = title.replace("&#009;", "\t");
		title = title.replace("&#037;", "%");
		title = title.replace("&#043;", "+");
		title = title.replace("&#039;", "'");
		title = title.replace("&amp;", "&");
		title = title.replace("&#059;", ";");
		title = title.replace("&#058;", ":");
		title = title.replace("&#035;", ":");
		title = title.replace("&quot;","\"");
		title = title.replace("&#064;","\n");
		title = title.replace("&#063;", "?");
		title = title.replace("&#061;", "=");
		title = title.replace("&#123;", "{");
		title = title.replace("&#091;", "[");
		title = title.replace("&#093;", "#");
		title = title.replace("&#042;", "*");
		title = title.replace("&#124;", "|");
		title = title.replace("&#096","`");
		
//		System.out.println(message);
//		for(int i = 0; i <message.length();i++){
//			if(message.charAt(i)=='&'){
//				System.out.println(currentName +" " + currentNews.getSymbol());
//			}
//		}
		File outputFile = new File("c:/master/newsTextFiles/"+currentNews.getSymbol()+"/"+currentName);
		File testDir = new File("c:/master/newsTextFiles/" + currentNews.getSymbol()+"/");
		if (!testDir.exists()){
			testDir.mkdir();
		}
//		System.out.println(message);
		try {
			FileOutputStream fos = new FileOutputStream(outputFile);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			bos.write((currentName +" " + currentNews.getSymbol() + "\n").getBytes());
			bos.write("<Title>".getBytes());
			bos.write(title.getBytes());
			bos.write("</Title><Message>".getBytes());
			bos.write(message.getBytes());
			bos.write("</Message>".getBytes());
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

}
