package newsProcessor;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import stockPrices.TimeSeries;
import trends.CheckTrend;
import trends.ClosestTime;

public class MatchNewsWithTrend2 extends Thread implements Serializable , Runnable{
	
	int period;
	double threshHold;
	TimeSeries ts;
	ArrayList<News> newsArray;
	File[] dirList;
//	File file;
	String nameOfCompany;
	String directory;
	
	public String getDirectory() {
		return directory;
	}
	public void setDirectory(String directory) {
		this.directory = directory;
	}
	public String getNameOfCompany() {
		return nameOfCompany;
	}
	public void setNameOfCompany(String nameOfCompany) {
		this.nameOfCompany = nameOfCompany;
	}
	public ArrayList<News> getNewsArray() {
		return newsArray;
	}
	public void setNewsArray(ArrayList<News> newsArray) {
		this.newsArray = newsArray;
	}
	public void setThreshHold(double threshHold) {
		this.threshHold = threshHold;
	}

	
	public MatchNewsWithTrend2(int period, double threshHold,TimeSeries ts,ArrayList<News> newsArray,String name, String directory, File[] dirList){
		setPeriod(period);
		setThreshhold(threshHold);
		setTs(ts);
		setNewsArray(newsArray);
		setNameOfCompany(name);
		setDirectory(directory);
		setDirList(dirList);
		
		
	}
//	public static int getTrend(File file, int period, double threshHold) throws IOException, ClassNotFoundException, InterruptedException{
	public int getPeriod() {
		return period;
	}

	public void setPeriod(int period) {
		this.period = period;
	}

	public double getThreshHold() {
		return threshHold;
	}

	public void setThreshhold(double threshhold) {
		this.threshHold = threshhold;
	}

	public TimeSeries getTs() {
		return ts;
	}

	public void setTs(TimeSeries ts) {
		this.ts = ts;
	}

	public File[] getDirList() {
		return dirList;
	}

	public void setDirList(File[] dirList) {
		this.dirList = dirList;
	}
//
//	public File getFile() {
//		return file;
//	}
//
//	public void setFile(File file) {
//		this.file = file;
//	}

	
	@SuppressWarnings("null")
	public static int getTrend(File file)  throws IOException, ClassNotFoundException, InterruptedException{
		
//		System.out.println(file.getName());
		File[] dirList = file.listFiles();
		if(dirList.length==0){
			return -1;
		}
		
		FileInputStream fis2 = new FileInputStream(new File("c:/master/timeseries/"+file.getName()));
//		System.out.println("TEST");
		BufferedInputStream bis = new BufferedInputStream(fis2);
		ObjectInputStream ois2 = new ObjectInputStream(bis);
		TimeSeries ts = (TimeSeries)ois2.readObject();
		ExecutorService exService = new ThreadPoolExecutor(4, 4, 10, TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6, true), new ThreadPoolExecutor.CallerRunsPolicy());
		ArrayList<News> newsArray = new ArrayList<>();
		for (int i = 0; i<dirList.length;i++){
			FileInputStream fis = new FileInputStream(dirList[i]);
			BufferedInputStream bis2 =  new BufferedInputStream (fis);
			ObjectInputStream ois = new ObjectInputStream(bis2);
			newsArray.add((News)ois.readObject());
		}
		String name = file.getName();
		String directory = file.getAbsolutePath();
		for(int period = 1; period <= 120; period++){
			for(double threshHold = 0.1; threshHold <= 0.4; threshHold +=0.1){
				Thread t = new MatchNewsWithTrend2(period, threshHold, ts, newsArray, name, directory, dirList);
				exService.submit(t);
				
				
			}
			
			
		}
		exService.shutdown();
		
//		if(!symbols.contains(news.getSymbol())){
//			System.out.println("KASDNKJASNdjk");
//			return -2;
//			
//		}
		
//		System.out.println(news.getSymbol());
		
		
		
		
		return 1;
		
		
	}
	
	public void run() {
		FileInputStream fis;
		try {
			ArrayList<NewsTrend> newsTrends = new ArrayList<>();
		
		if(!new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/").exists()){
			new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/").mkdir();
		}
		File newDir = new File("c:/master/trendsbystock/trendsbystock" + period + "min" + threshHold + "/" + nameOfCompany);
		if(!newDir.exists()){
			newDir.mkdir();
//			System.out.println("created directory: " + newDir.getAbsolutePath());
		}
		else if(!(newDir.listFiles().length == 0)){
			Thread.currentThread().interrupt();
			return;
		}
		
		for (int i = 0; i < newsArray.size(); i++) {
			
			
//				fis = new FileInputStream(new File("c:/master/processednewsbystock/" + nameOfCompany+"/"+newsArray.get(i).getName()));
//			
//			ObjectInputStream ois = new ObjectInputStream(fis);
//			
//			News news = (News)ois.readObject();
//			
			String date = newsArray.get(i).getDate();
			
//			System.out.println("fr ct");
//			System.out.println(news.getDate());
//			System.out.println(news.getDate().length());
//			System.out.println(ts.getDate().size());
//			System.out.println(news.getSymbol());
			if (ts.getDate().size()==0) {
				continue;
			}
			if(Integer.parseInt(date.substring(0,8))<ts.getDate().get(0)){
//				System.out.println(dirList[i].getAbsolutePath() + "skipped");
				continue;
			}
//			System.out.println(date);
//			System.out.println("fr ct");
//			System.out.println(dirList[i].getName());
//			if (news.getName().equals("AKVA")){
//				System.out.println(dirList[i].getName());
//			}
//			System.out.println(dirList[i].getName());
			ClosestTime ct = new ClosestTime(date, ts);
//			System.out.println("etter ct");
			
			int trend = -2;
			
			if(ct.isFalse==false){
				CheckTrend cTrend = new CheckTrend(ct.getTransactionID(),ts.getTime().get(ct.getTransactionID()), period , ct.getOffset() , ct.getDayDiff(), ts,  threshHold, 0.3, ct.isAfterClosing, date);
				
				trend = cTrend.getDirection();
				if (cTrend.getNumOfTransactions()==0){
					trend = -2;
				}
//				System.out.println("IKASDJKn");
			}
			NewsTrend nt = new NewsTrend(dirList[i].getName(), trend, dirList[i].getAbsolutePath());
			
			newsTrends.add(nt);
//			FileOutputStream fos = new FileOutputStream(newDir+"/"+dirList[i].getName());
////			System.out.println(trend);
//			fos.write(("" +trend).getBytes());
//			fos.close();
			
			
			}
		FileOutputStream fos = new FileOutputStream(newDir + "/newsTrends");
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(newsTrends);
		
	}
		catch (Exception e) {
			// TODO: handle exception
		}
		
	}
}
	

