package posTagging;

import java.awt.List;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import edu.stanford.*;
import edu.stanford.nlp.classify.ClassifierFactory;
import edu.stanford.nlp.ie.crf.CRFClassifier;
import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;
import edu.stanford.nlp.util.CoreMap;

public class DoPOSTagging {

	public static int findIndexOfSequence(String sequence, String line){
		
		int length = sequence.length();
		String tempString = "";
		int index = 0;
		while(!tempString.equals(sequence)){
			if (index == line.length()){
				return -1;
			}
			tempString+= line.charAt(index);
			if(tempString.length()>length){
				tempString = tempString.substring(1);
			}
			index++;
			
		}
		return index;
		
		
	}
	
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws ClassCastException, ClassNotFoundException, IOException {
		MaxentTagger tagger;
		CRFClassifier<? extends CoreMap> NERtagger = CRFClassifier.getClassifier(new File("c:/test/NEr/classifiers/english.all.3class.distsim.crf.ser.gz"));
		
		try{
			tagger = new MaxentTagger("c:\\test\\pos\\models\\english-left3words-distsim.tagger");
			
		}
		catch (Exception e) {
			// TODO: handle exception
			throw new RuntimeException(e);
		}
		File dir = new File("c:/master/newsTextFiles/");
		File[] dirList = dir.listFiles();
		for(int dirIndex = 0; dirIndex<dirList.length;dirIndex++){
			File[] dirDirList = dirList[dirIndex].listFiles();
			for(int dirDirIndex = 0; dirDirIndex< dirDirList.length;dirDirIndex++){
				if(new File("c:/master/NERPOStagged/" + dirDirList[dirDirIndex].getName()).exists()){
					continue;
				}
				java.util.List<? extends java.util.List<? extends HasWord>> list = MaxentTagger.tokenizeText(new FileReader(dirDirList[dirDirIndex]));
				@SuppressWarnings("unchecked")
				java.util.List<? extends java.util.List<? extends CoreMap>> list2 = (java.util.List<? extends java.util.List<? extends CoreMap>>) list;
				java.util.List<? extends java.util.List<? extends HasWord>> PosTags = tagger.process(list);
				String NerTags = NERtagger.classifyToString(list.toString());
//				java.util.List<? extends java.util.List<? extends HasWord>> NerTags = null;
//				System.out.println(NerTags);
//				System.out.println(PosTags.toString());
//				System.out.println(list.toString());
				
				String outputString = "";
//				System.out.println(list.get(0).size());
//				System.out.println(PosTags.get(0).size());
				
				outputString += "Term \t\t PosTag \t\t Nertag \t\t Significance \n";
				for(int i = 0; i < list.size();i++){
					for (int j = 0; j < list.get(i).size(); j++){
						
						String temp = list.get(i).get(j).toString();
						int index = findIndexOfSequence(temp, NerTags);
						if(index == -1){
							continue;
						}
						outputString+= temp + "\t\t";
						String tempPosString = PosTags.get(i).get(j).toString();
						if(list.get(i).get(j).toString().contains("/")){
							
						}
						outputString+= tempPosString.substring(temp.length()+1) + "\t\t";
						
						
						int newIndex = index;
//						System.out.println(dirDirList[dirDirIndex].getName());
//						System.out.println(temp);
//						System.out.println("HEYO" + newIndex);
						while(NerTags.charAt(newIndex)!=' ' && NerTags.charAt(newIndex)!=',' && NerTags.charAt(newIndex)!= '-' && newIndex!=NerTags.length()-1){
//							System.out.println(newIndex);
							newIndex++;
						}
						String superTemp = NerTags.substring(index, newIndex);
						
						if(superTemp.length()!= 0){
							superTemp = superTemp.substring(1);
							
						}
						else {
							superTemp="O";
						}
						if(superTemp.length()==0){
							superTemp="O";
						}
						else {
							if(superTemp.charAt(0)=='\\'){
								superTemp="O";
							}
						}
						outputString +=  superTemp + "\t\tO\n";
						NerTags =NerTags.substring(newIndex);
						
						
					}
				}
//				System.out.println(outputString);
				FileOutputStream fos = new FileOutputStream(new File("c:/master/NERPOStagged/" + dirDirList[dirDirIndex].getName()));
				fos.write(outputString.getBytes());
			}
		}
		
		
		
		
//		for(int i = 0; i<list.size();i++){
//			NerTags.add(NERtagger.classifySentence(list.get(i)));
//		}
		
//		tagger.runTagger(new BufferedReader(new FileReader(new File("c:/master/newsTextfiles/AFK/244045"))), new BufferedWriter(new FileWriter(new File("c:/master/test.txt"))), arg2, arg3)
	}
	

}
