package stockPrices;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;


public class CreateTimeSeries implements java.io.Serializable {
	

// This method creates a collection of all timeseries for all the keys. Currently not in use.
	public static HashMap<String, TimeSeries> createSeriesCollection(FilePaths filePaths) throws FileNotFoundException, IOException{
		HashMap<String, TimeSeries> series = new HashMap<>();
		for(int i = 0;i<filePaths.getKeys().size();i++){
			String key = filePaths.getKeys().get(i);
			System.out.println(key);
			series.put(key, createSeries(filePaths.getFilePaths().get(key), key));
		}

		
		return series;
	}
	
	//Creates a TimeSeries object from a list of transactions.
	public static TimeSeries createSeries(ArrayList<String> paths, String name) throws IOException, FileNotFoundException{
		ArrayList<Double> prices = new ArrayList<>();
		ArrayList<String> time = new ArrayList<>();
		ArrayList<Integer> date = new ArrayList<>();
		ArrayList<Integer> quantity = new ArrayList<>();
		
		//Read all the files assosiated with the ticker
		for(int i = 0; i < paths.size(); i++){
			FileReader fr = new FileReader(new File(paths.get(i)));
			BufferedReader br = new BufferedReader(fr);
			//The first line is skipped, because it contains the name of the fields.
			br.readLine();
			
			//Read every line and extract the date, transaction price and quantity.
			while(br.ready()){
				String content = br.readLine();
				if (content.length()<10){
					break;
				}
				String tempTime = "";
				String tempPrice = "";
				String tempDate = "";
				String tempQuantity = "";
				
				int tabcount = 0;
				int firstSpace = 0;
				String tempString="";
				for(int j = 0; j < content.length(); j++){
					if (content.charAt(j) == '\t'){
						tempString=content.substring(firstSpace, j);
						firstSpace = j+1;
						if(tabcount == 0){
							tempTime=tempString;
							tempDate=tempString.substring(0, 8);
						}
						else if (tabcount == 1){
							tempPrice = tempString;
						}
						else if (tabcount == 2){
							tempQuantity = tempString;
						}
						tabcount++;
					}
				}
				prices.add(Double.parseDouble(tempPrice));
				time.add(tempTime);
				date.add(Integer.parseInt(tempDate));
				
				//Removing some error in the input data.
				if(tempQuantity.equals("55ade")){
					System.out.println(tempTime);
				}
				quantity.add(Integer.parseInt(tempQuantity));
				
			}
		}
		//Returns a TimeSeries object
		return new TimeSeries(name, prices, date, time, quantity);
	}

}
