package stockPrices;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;

public class LoadPrices implements java.io.Serializable {
	

	ArrayList<TimeSeries> timeSeries = new ArrayList<TimeSeries>();
	

	@SuppressWarnings("null")
	public static FilePaths getFilePaths(File rootDirectory){
		
		//Create a Hashmap with key = Ticker and value = list of all filenames connected to that ticker.
		HashMap<String, ArrayList<String>> filePaths = new HashMap<>();
		ArrayList<String> keys = new ArrayList<>();
		
		//Traversing the folders. They are organized into years, months and days.
		File dir = rootDirectory;
		File[] yearList = dir.listFiles();
		for (int i = 0; i < yearList.length;i++){
			
			File[] monthsList = yearList[i].listFiles();
			
			for(int j = 0; j < monthsList.length; j++){
				
				File[] dayList = monthsList[j].listFiles();
				
				for(int k = 0; k < dayList.length; k++){
					
					File[] stocks = dayList[k].listFiles();
					
					for(int m = 0; m < stocks.length; m++){
						
						String stockName = stocks[m].getName();
						//Removing some files that cause problems.
						if (!Character.isUpperCase(stockName.charAt(0))){
							continue;
						}
						//Removing Fileextentions
						
						stockName = stockName.substring(0, stockName.length()-4);
						
						if(stockName.equals("TidKursVolum")){
							continue;
						}
						
						//If the hashmap does not contain the key, add the key to the hashmap
						if (filePaths==null){
							ArrayList<String> paths = new ArrayList<>();
							filePaths.put(stockName, paths);
						}
						
						else if(!filePaths.containsKey(stockName)) {
							ArrayList<String> paths = new ArrayList<>();
							filePaths.put(stockName, paths);
						}
						filePaths.get(stockName).add(stocks[m].getAbsolutePath());

						//add the Key to the list of keys.
						if (!keys.contains(stockName)){
							keys.add(stockName);
						}
					}
				}
			}
		}
		//return a Filepaths object with a list of filepaths and the list of keys.
		return new FilePaths(filePaths,keys);
	}
	

}
