package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import newsProcessor.NewsTrend;

public class CreateSVMLightFiles extends Thread{
	
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		File[] dirlist = new File("c:/master/trendsbystock/trendsbystock44min0.5/").listFiles();
		
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
		for(int i = 0; i < dirlist.length; i++){
			
			ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File(dirlist[i].getAbsolutePath()+"/newstrends"))));
			ArrayList<NewsTrend> newsTrends = (ArrayList<NewsTrend>) ois.readObject();
			Thread t = new CreateSVMLightFiles(newsTrends);
			exService.submit(t);
			
			
			
			
		}
		exService.shutdown();
	}


	ArrayList<NewsTrend> newsTrends;
	public CreateSVMLightFiles(ArrayList<NewsTrend> newsTrends){
		setNewsTrends(newsTrends);
	}
	
	public ArrayList<NewsTrend> getNewsTrends() {
		return newsTrends;
	}
	public void setNewsTrends(ArrayList<NewsTrend> newsTrends) {
		this.newsTrends = newsTrends;
	}
	public void run(){
		try{
			ArrayList<NewsTrend> newsTrends = getNewsTrends();
			for(int j = 0; j < newsTrends.size(); j++){
				if(newsTrends.get(j).getDirection()!=-2){
					String name = newsTrends.get(j).getDirectory().substring(newsTrends.get(j).getDirectory().length()-6);
					File readFile = new File("c:/master/svmprocess/tfidf/" + name);
					if(!readFile.exists()){
						continue;
					}
					ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(readFile)));
					
					ArrayList<Double> tfidfVector = (ArrayList<Double>) ois2.readObject();
					
					BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmProcess/SVMLightFiles/" + name + ".txt")));
					
					String outputString = "#header\n";
					
					outputString += newsTrends.get(j).getDirection() + " ";
					for(int k = 0; k < tfidfVector.size(); k++){
						if(tfidfVector.get(k)!= 0){
							outputString += k+1 + ":" + tfidfVector.get(k) + " ";
						}
					}
					outputString+="\n";
	//				System.out.println(outputString);
					bos.write(outputString.getBytes());
					bos.close();
				}
				
				
			}
		} catch (IOException e){
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
