package svm;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class CreateTrainingDocs extends Thread {
	
	File[] dirListFile;
	int iteration;
	double trainigTestRatioNumber;
	String posNegString;
	public File[] getDirListFile() {
		return dirListFile;
	}

	public void setDirListFile(File[] dirListFile) {
		this.dirListFile = dirListFile;
	}

	public int getIteration() {
		return iteration;
	}

	public void setIteration(int iteration) {
		this.iteration = iteration;
	}

	public double getTrainigTestRatioNumber() {
		return trainigTestRatioNumber;
	}

	public void setTrainigTestRatioNumber(double trainigTestRatioNumber) {
		this.trainigTestRatioNumber = trainigTestRatioNumber;
	}

	public String getPosNegString() {
		return posNegString;
	}

	public void setPosNegString(String posNegString) {
		this.posNegString = posNegString;
	}

	public CreateTrainingDocs(File[] dirList, int iteration, double trainingTestRatio, String posNeg){
		setDirListFile(dirList);
		setIteration(iteration);
		setTrainigTestRatioNumber(trainingTestRatio);
		setPosNegString(posNeg);
	}
	
	public static void main(String[] args) throws IOException {
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
		File[] dirList = new File("c:/master/svmProcess/svmLightFiles/").listFiles();
		String posNeg = "";
		double trainTestRatio = 0.9;
		for(int posNegCounter = 0; posNegCounter<2; posNegCounter++){
			
			if(posNegCounter==0){
				posNeg= "pos";
			}
			else {
				posNeg="neg";
			}
			
			for (int i = 1; i <= 10;i++){
				
				Thread t = new CreateTrainingDocs(dirList, i, trainTestRatio, posNeg);
				exService.submit(t);
			}
				
		}
		exService.shutdown();
	}
	public void run(){
		try{
			int i = getIteration();
			String posNeg = getPosNegString();
			File[]dirList = getDirListFile();
			double trainTestRatio = getTrainigTestRatioNumber();
			String trainingString = "#header\n";
			String testString = "#header\n";
			int startIndex = dirList.length - dirList.length/i;
			int counter = 0;
			int length = dirList.length;
			while(counter < length){
				BufferedReader br = new BufferedReader(new FileReader(dirList[startIndex]));
				br.readLine();
				String tempString = br.readLine();
				if(posNeg.equals("pos")){
					switch(tempString.charAt(0)){
					case('0'):{tempString = "-1" + tempString.substring(1);break;}
					case('-'):{tempString = "-1" + tempString.substring(2);break;}
					case('1'):{tempString = "1" + tempString.substring(1);break;}
					}
					if(counter<0.9*length){
						trainingString+=tempString+"\n";
					}
					else {
						testString += tempString+"\n";
					}
				}
				else if (posNeg.equals("neg")) {
					switch(tempString.charAt(0)){
					case('0'):{tempString = "-1" + tempString.substring(1);break;}
					case('-'):{tempString = "1" + tempString.substring(2);break;}
					case('1'):{tempString = "-1" + tempString.substring(1);break;}
					}
					if(counter<trainTestRatio*length){
						trainingString+=tempString+"\n";
					}
					else {
						testString += tempString+"\n";
					}
					
					
				}
				
						
				counter++;
				if(counter%10000==0){
					System.out.println(counter);
				}
				startIndex++;
				if(startIndex>=length){
					startIndex=0;
					
				}
				
				
			}
			BufferedOutputStream trainingOutputStream = new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmProcess/trainingfiles/" + posNeg + "/" + i +"iteration" + posNeg + "TrainingFile.txt")));
			BufferedOutputStream testOutputStream = new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmProcess/trainingfiles/" + posNeg + "/" + i +"iteration" + posNeg + "TestFile.txt")));
			
			trainingOutputStream.write(trainingString.getBytes());
			trainingOutputStream.close();
			testOutputStream.write(testString.getBytes());
			testOutputStream.close();
			System.out.println("done with iteration " + i);
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}


