package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import newsProcessor.NewsTrend;

public class CreateWekaFiles {
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		try{
			String outputString = "%header\n%Masteroppgave Simen Kind Gulbrandsen\n@RELATION Datasamling\n";
			
			ObjectInputStream oisFV = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmProcess/featurevector2"))));
			ArrayList<Feature> featureVector = (ArrayList<Feature>) oisFV.readObject();
			int numberoffeatures = featureVector.size();
			for(int i = 0; i<featureVector.size();i++){
				outputString+="@ATTRIBUTE\t";
				outputString+= i;
				
				
				outputString+="\tNUMERIC\n";
				
			}
			outputString+="@ATTRIBUTE\tClass\t{pos,neg,zero}\n\n@DATA\n";
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/master/weka/WekaSet.arff")));
			
			File[] dirlist = new File("c:/master/trendsbystock/trendsbystock44min0.5/").listFiles();
			
			ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
			for(int i = 0; i < dirlist.length; i++){
				
				ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File(dirlist[i].getAbsolutePath()+"/newstrends"))));
				ArrayList<NewsTrend> newsTrends = (ArrayList<NewsTrend>) ois.readObject();
				for(int j = 0; j < newsTrends.size(); j++){
					if(newsTrends.get(j).getDirection()!=-2){
						String name = newsTrends.get(j).getDirectory().substring(newsTrends.get(j).getDirectory().length()-6);
						File readFile = new File("c:/master/svmprocess/tfidf2/" + name);
						if(!readFile.exists()){
							continue;
						}
						ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(readFile)));
						ArrayList<Double> tfidfVector = (ArrayList<Double>) ois2.readObject();
						
						outputString+="{";
						for(int k = 0; k < tfidfVector.size(); k++){
							if(tfidfVector.get(k)>0){
								outputString += k + " " + tfidfVector.get(k) + ",";
							}
						}
						switch(newsTrends.get(j).getDirection()){
						case(-1):outputString += numberoffeatures + " neg}\n";break;
						case(0):outputString += numberoffeatures + " zero}\n";break;
						case(1):outputString +=numberoffeatures + " pos}\n";break;
						}
						
		//				System.out.println(outputString);
						bos.write(outputString.getBytes());
						
						outputString="";
					}
				
				
				
				
				
				}
		
			
				
				
			}
			bos.close();
		} catch (IOException e){
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	ArrayList<NewsTrend> newsTrends;
	public CreateWekaFiles(ArrayList<NewsTrend> newsTrends){
		setNewsTrends(newsTrends);
	}
	
	public ArrayList<NewsTrend> getNewsTrends() {
		return newsTrends;
	}
	public void setNewsTrends(ArrayList<NewsTrend> newsTrends) {
		this.newsTrends = newsTrends;
	}
	public void run(){
		
	}


}
