package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import trends.RegressionObject;

import newsProcessor.NewsTrend;

public class CreateWekaFilesRegression {
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		try{
			String outputString = "%header\n%Masteroppgave Simen Kind Gulbrandsen\n@RELATION Datasamling\n";
			
			ObjectInputStream oisFV = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmProcess/featurevector"))));
			ArrayList<Feature> featureVector = (ArrayList<Feature>) oisFV.readObject();
			for(int i = 0; i<featureVector.size();i++){
				outputString+="@ATTRIBUTE\t";
				outputString+= i;
				
				
				outputString+="\tNUMERIC\n";
				
			}
			outputString+="@ATTRIBUTE\tClass\t{pos,neg,zero}\n\n@DATA\n";
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/master/weka/WekaSetRegression.arff")));
			
			ObjectInputStream readRegressionObject = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/Master/regressionresults/regressionresults"))));
			HashMap<String, RegressionObject> map = (HashMap<String, RegressionObject>) readRegressionObject.readObject()
					;
			File[] dirlist = new File("c:/master/processednews/").listFiles();
			
			ExecutorService exService = new ThreadPoolExecutor(6, 6, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6,true), new ThreadPoolExecutor.CallerRunsPolicy());
			int countPos = 0;
			int countNeg = 0;
			int countZero = 0;
			for(int i = 0; i < dirlist.length; i++){
				
					int direction = 0;
					double significanceLevel = 1;
					double thresHold = 0.00005;
					int period = 43;
					String key = "" + dirlist[i].getName()+"min"+period;
					if (!map.containsKey(key)){
						continue;
					}
					RegressionObject tempObject = map.get(key);
					
					double gain = ((tempObject.getSr().getIntercept() + tempObject.getSr().getSlope()*period*60) - tempObject.getSr().getIntercept())/tempObject.getSr().getIntercept();
					
					if(gain > thresHold && tempObject.getSr().getSignificance() <significanceLevel){
						direction = 1;
						countPos++;
					}
					else if( gain < -1*thresHold && tempObject.getSr().getSignificance() < significanceLevel){
						direction = -1;
						countNeg++;
					}
					else {
						direction = 0;
						countZero++;
					}
					
					
					if(true){
						String name = dirlist[i].getName();
						File readFile = new File("c:/master/svmprocess/tfidf/" + name);
						if(!readFile.exists()){
							continue;
						}
						ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(readFile)));
						ArrayList<Double> tfidfVector = (ArrayList<Double>) ois2.readObject();
						
						outputString+="{";
						for(int k = 0; k < tfidfVector.size(); k++){
							if(tfidfVector.get(k)!=0){
								outputString += k + " " + tfidfVector.get(k) + ",";
							}
						}
						switch(direction){
						case(-1):outputString += "7690 neg}\n";break;
						case(0):outputString += "7690 zero}\n";break;
						case(1):outputString += "7690 pos}\n";break;
						}
						
		//				System.out.println(outputString);
						bos.write(outputString.getBytes());
//						System.out.println(outputString
						outputString="";
					}
				
				
				
				
				
				
		
			
				
				
			}
			bos.close();
			System.out.println("pos: " + countPos);
			System.out.println("neg: " + countNeg);
			System.out.println(("zero: " + countZero));
		} catch (IOException e){
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	ArrayList<NewsTrend> newsTrends;
//	public CreateWekaFiles(ArrayList<NewsTrend> newsTrends){
//		setNewsTrends(newsTrends);
//	}
	
	public ArrayList<NewsTrend> getNewsTrends() {
		return newsTrends;
	}
	public void setNewsTrends(ArrayList<NewsTrend> newsTrends) {
		this.newsTrends = newsTrends;
	}
	public void run(){
		
	}


}
