package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

public class RemoveSparseFeatures {
	// Denne klassen fjerner alle termer som ikke finnes i mer enn 4 dokumenter i samlingen. 
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		
		ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/documentFrequency"))));
		ObjectInputStream ois2 = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/svmprocess/FeatureVector"))));
		ArrayList<Integer> documentFrequency = (ArrayList<Integer>) ois.readObject();
		ArrayList<Feature> featureVector = (ArrayList<Feature>) ois2.readObject();
		
		System.out.println(documentFrequency.size());
		System.out.println(featureVector.size());
		int maxDf = 0;
		for(int i = 0; i < documentFrequency.size();i++){
			if (documentFrequency.get(i)>maxDf){
				maxDf=documentFrequency.get(i);
			}
		}
		int docThreshold = (int) Math.floor(maxDf*0.8);
		for(int i = documentFrequency.size()-1; i>=0 ;i--){
//			System.out.println(documentFrequency.get(i));
			if(documentFrequency.get(i) < 5 || documentFrequency.get(i)>docThreshold){ 
				documentFrequency.remove(i);
				featureVector.remove(i);
			}
		}
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmprocess/documentfrequency"))));
		ObjectOutputStream oos2 = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmprocess/FeatureVector"))));
		oos.writeObject(documentFrequency);
		oos2.writeObject(featureVector);
		
		oos.close();
		oos2.close();
		System.out.println(documentFrequency.size());
		System.out.println(featureVector.size());
	}

}
