package svm;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.lang.ProcessBuilder.Redirect;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class RunSVM extends Thread {

	public static void main(String[] args) {
		
		ExecutorService exService = new ThreadPoolExecutor(3, 3, 10,TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(3,true), new ThreadPoolExecutor.CallerRunsPolicy());
		for(int i = 1; i <=10; i++){
			File trainingFile = new File("c:/master/svmProcess/trainingFiles/pos/"+i+"iterationposTrainingFile.txt");
			File testFile = new File("c:/master/svmProcess/trainingfiles/pos/"+i+"iterationposTestFile.txt");
			Thread t = new RunSVM(trainingFile.getAbsolutePath(), "c:/master/svmProcess/trainingfiles/posModels/" +i+"posModelFile", testFile.getAbsolutePath(), i, "pos");
			exService.submit(t);
			trainingFile = new File("c:/master/svmProcess/trainingFiles/neg/"+i+"iterationnegTrainingFile.txt");
			testFile = new File("c:/master/svmProcess/trainingfiles/neg/"+i+"iterationnegTestFile.txt");
			t = new RunSVM(trainingFile.getAbsolutePath(), "c:/master/svmProcess/trainingfiles/negModels/" +i+"negModelFile", testFile.getAbsolutePath(), i, "neg");
			exService.submit(t);
			
		}
//		File trainingFile = new File("c:/master/svmProcess/trainingFiles/pos/"+9+"iterationposTrainingFile.txt");
//		File testFile = new File("c:/master/svmProcess/trainingfiles/pos/"+9+"iterationposTestFile.txt");
//		Thread t = new RunSVM(trainingFile.getAbsolutePath(), "c:/master/svmProcess/trainingfiles/posModels/" +9+"posModelFile", testFile.getAbsolutePath(), 9, "pos");
//		exService.submit(t);
		exService.shutdown();
		
	}
	int iteration;
	String trainingFilepath, modelFilePath, testFilePath, posNeg;
	public String getPosNeg() {
		return posNeg;
	}

	public void setPosNeg(String posNeg) {
		this.posNeg = posNeg;
	}

	public String getModelFilePath() {
		return modelFilePath;
	}

	public void setModelFilePath(String modelFilePath) {
		this.modelFilePath = modelFilePath;
	}

	public String getTestFilePath() {
		return testFilePath;
	}

	public void setTestFilePath(String testFilePath) {
		this.testFilePath = testFilePath;
	}

	public RunSVM(String trainingFilePath, String modelFilePath, String testFilePath, int iteration, String posNeg){
	
		setTrainingFilepath(trainingFilePath);
		setIteration(iteration);
		setTestFilePath(testFilePath);
		setModelFilePath(modelFilePath);
		setPosNeg(posNeg);
		
	}
	
	public int getIteration() {
		return iteration;
	}
	public void setIteration(int iteration) {
		this.iteration = iteration;
	}
	
	public String getTrainingFilepath() {
		return trainingFilepath;
	}

	public void setTrainingFilepath(String trainingFilepath) {
		this.trainingFilepath = trainingFilepath;
	}

	public void run(){
		System.out.println(getPosNeg() + " iteration " + getIteration() + " Commencing classification");
		ProcessBuilder pb = new ProcessBuilder("c:/svmlight/svm_learn.exe","-c", "100","-t","2","-g","10", getTrainingFilepath(), getModelFilePath());
		File log = new File("c:/master/svmProcess/trainingfiles/logs/"+ getIteration() + getPosNeg() + "logFile.txt");
		pb.redirectErrorStream(true);
		pb.redirectOutput(Redirect.to(log));
		
		try {
			Process process = pb.start();
			long counter = 0;
//			if(getIteration()==1 && getPosNeg().equals("pos")){
//				while(true){
//					try {
//						counter ++;
//						System.out.print((char)process.getInputStream().read());
//						if(counter == 1000000000){
//							break;
//						}
//					} catch (Exception e) {
//						// TODO: handle exception
//					}
//					
//				}
//			}
			
			process.waitFor();
			process.getErrorStream().close();
			process.getInputStream().close();
			process.getOutputStream().close();
			System.out.println(getPosNeg() + " iteration " + getIteration() + " done Learning. Commencing classification");
			ProcessBuilder pb2 = new ProcessBuilder("c:/svmlight/svm_classify.exe",getTestFilePath(), getModelFilePath(), "c:/master/svmProcess/tempFiles/" + getPosNeg() + "/" + iteration + "file");
			Process process2;
		
			process2 = pb2.start();
			process2.waitFor();
			process2.getErrorStream().close();
			process2.getInputStream().close();
			process2.getOutputStream().close();
			System.out.println(getPosNeg() + " iteration " + getIteration() + " done Classifying. Commencing evaluation");
		
			File resultsFile = new File("c:/master/svmProcess/tempfiles/" + posNeg + "/" + iteration + "file");
		
		
			System.out.println(getIteration() + getPosNeg());
			BufferedReader brTestFile = new BufferedReader(new FileReader(new File(getTestFilePath())));
			BufferedReader brResultsFile = new BufferedReader(new FileReader(resultsFile));
			
			brTestFile.readLine();
			int TP = 0;
			int TN = 0;
			int FP = 0;
			int FN = 0;
			while(brTestFile.ready()){
				String testContent = brTestFile.readLine();
				String resultsContent = brResultsFile.readLine();
				if(testContent.length()!=0 && resultsContent.length()!=0){
					char test = testContent.charAt(0);
					char results = resultsContent.charAt(0);
					if(results == '0'){
						results ='1';
					}
					if(test == results){
						if (test== '-'){
							TN++;
						}
						else if( test == '1'){
							TP++;
						}
					}
					else {
						if(test =='-'){
							FP++;
						}
						else if(test == '1'){
							FN++;
						}
					}
					
					
					
				}
				
			}
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File("c:/master/svmProcess/trainingfiles/" + posNeg + "Evaluated/" + getIteration()+"evaluated.txt")));
			
			String outputString = "True Positives:\n" +TP +"\nTrue Negatives:\n" + TN + "\nFalse Positives:\n" + TP + "\nFalse Negatives:\n" + FN+"\n";
			bos.write(outputString.getBytes());
			bos.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
	}
	
}
