package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.HashMap;

import org.apache.commons.math3.stat.regression.SimpleRegression;

import trends.RegressionObject;

public class FindBestPeriod {

	public static void main(String[] args) throws ClassNotFoundException, IOException {
		
		double regressionSignificanseLimit = 0.05;
		double tresHold = 0.01;
		int maxlength = 240;
		ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(new FileInputStream(new File("c:/master/regressionresults/regressionresults"))));
		HashMap<String,RegressionObject> map = (HashMap<String,RegressionObject>) ois.readObject();
		
		File[] dirList = new File("c:/master/processednewsbystock/").listFiles();
		ArrayList<ArrayList<Double>> periods = new ArrayList<>();
		for(int fill = 0; fill <= maxlength; fill++){
			periods.add(new ArrayList<Double>());
		}
		
		for(int i = 0; i < dirList.length; i++){
			System.out.println(dirList[i].getName());
			File[] subDirList = dirList[i].listFiles();
			for(int j = 0; j < subDirList.length;j++){
				for(int periode = 1; periode<=maxlength; periode++ ){
					if(!map.containsKey(subDirList[j].getName()+"min"+periode)){
						continue;
					}
					
					RegressionObject ro = map.get(subDirList[j].getName()+"min"+periode);
					
					
					SimpleRegression sr = ro.getSr();
					
					double slope = sr.getSlope();
					double intercept = sr.getIntercept();
					
					double significance = sr.getSignificance();
					
					if (significance < regressionSignificanseLimit){
						
						double gain = 0;
						if(slope<0){
							gain = (intercept - slope*60*periode)/intercept;
						}
						else {
							gain = (intercept + slope*60*periode)/intercept;
						}
						if(gain < tresHold){
							continue;
						}
//						gain = Math.abs(slope/intercept);
						ArrayList<Double> tempPeriods = periods.get(periode);
						tempPeriods.add(gain);
						periods.set(periode, tempPeriods);
					}
					
				}
			}
		}
		double maxGain = 0;
		double maxSig = 0;
		int maxGainPeriode = 0;
		int maxSigPeriode = 0;
		int maxGainCount = 0;
		double fortjeneste = 0;
		double maxFortjeneste = 0;
		double maxFortjenestePeriode = 0;
		
		for (int periode = 1; periode<=maxlength; periode++){
			ArrayList<Double> values = periods.get(periode);
			double tempGain = 0;
			double tempSig = values.size();
			
			if (tempSig>maxSig){
				maxSig = tempSig;
				maxSigPeriode = periode;
			}
			
			for(int i = 0; i <values.size(); i++){
				tempGain+=values.get(i);
			}
			tempGain=tempGain/values.size();
			
			
			if(tempGain>maxGain){
				maxGain = tempGain;
				maxGainPeriode = periode;
				maxGainCount = values.size();
			}
			
			for( int counts = 0; counts < tempSig; counts++){
				fortjeneste += (100000 * tempGain)-100000;
			}
			if(maxFortjeneste<fortjeneste){
				maxFortjeneste = fortjeneste;
				maxFortjenestePeriode = periode;
			}
			System.out.println("Periode: " + periode + ", Cases: " + tempSig + ", Fortjeneste: " + tempGain);
		}
		System.out.println("Signifikanse satt til: " + regressionSignificanseLimit);
		System.out.println("Flest signifikante: " + maxSigPeriode + " med " + maxSig +" gyldige");
		System.out.println("Strst fortjeneste: " + maxGainPeriode + " med " + maxGain + "prosent avkastning. Antall gyldige: " + maxGainCount);
		System.out.println("Fortjeneste: " + maxFortjeneste + " med periode " + maxFortjenestePeriode);
		
	}
}
