package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.concurrent.Callable;

import ptolemy.gui.SettableQueryChooser;

import stockPrices.TimeSeries;
import trends.ClosestTime;

import newsProcessor.News;
import newsProcessor.NewsTrend;

public class TestTrade implements Callable<Double>{
	
	private static TimeSeries ts;
	private  static double tresHold, moneyPerTransaction;
	private  static int period;
	
	public TimeSeries getTs() {
		return ts;
	}
	public void setTs(TimeSeries ts) {
		this.ts = ts;
	}
	public double getTresHold() {
		return tresHold;
	}
	public void setTresHold(double tresHold) {
		this.tresHold = tresHold;
	}
	public double getMoneyPerTransaction() {
		return moneyPerTransaction;
	}
	public void setMoneyPerTransaction(double moneyPerTransaction) {
		this.moneyPerTransaction = moneyPerTransaction;
	}
	public int getPeriod() {
		return period;
	}
	public void setPeriod(int period) {
		this.period = period;
	}
	public TestTrade(TimeSeries ts, double tresHold, double moneyPerTransaction, int period) throws IOException, ClassNotFoundException{
		setTs(ts);
		setTresHold(tresHold);
		setMoneyPerTransaction(moneyPerTransaction);
		setPeriod(period);
		
		
		
	}
//				if(direction == 1 || direction == -1){
//				System.out.println(list.get(i).getName() + ": " + direction);
//				
//				}
//			}
//			else {
//				System.out.println(list.get(i).getName() + ": " + direction);
//			}
//		double results = 0;
//		
//		for(int i = 0; i < newsTrends.size(); i ++){
//			String symbol = "";
//			String time = "";
//			
//			for(int j = 0; j<newsArray.size();j++){
//				if(newsArray.get(j).getName().equals(newsArray.get(i))){
//					symbol = newsArray.get(j).getSymbol();
//					time = newsArray.get(j).getDate();
//					break;
//				}
//			}
//			
//		}
//
//		return results;
//	}

	public static double buyStocks(String symbol, TimeSeries ts, int period, double moneyPerTransactions, String time, boolean shortTrade){
		
		double results = 0;
		
		ClosestTime buyTime = new ClosestTime(time, ts);
//		System.out.println(time);
		int stopTime = Integer.parseInt(time.substring(time.length()-6)) + period;
		if(stopTime%10000>5900){
			stopTime+=4000;
		}
		if(stopTime%1000000>595900){
			stopTime+=400000;
		}
		String stopString = "";
		if (stopTime<100000){
			stopString = time.substring(0,time.length()-6)+"0" + stopTime;
		}
		else {
			stopString = time.substring(0,time.length()-6) + stopTime;
		}
		
		
		ClosestTime sellTime = new ClosestTime(stopString, ts);
		if(sellTime.getPrevTime() == null || buyTime.getPrevTime() == null){
//			System.out.println("problem");
			return 0.0;
		}
		
		if (buyTime.getPrevTime().equals(sellTime.getPrevTime())) {
//			System.out.println("no trade!");
			return 0.0;
			
		}
		double buyPrice = ts.getPrices().get(buyTime.getTransactionID());
//		System.out.println(buyPrice);
		int numOfStocks = (int) (moneyPerTransactions / buyPrice);
		double buyAmount = numOfStocks * buyPrice;
		
		double sellPrice = ts.getPrices().get(sellTime.getTransactionID());
		double sellAmount = numOfStocks * sellPrice;
//		System.out.println(sellPrice);
		if(shortTrade){
			results = buyAmount-sellAmount;
//			System.out.println("short");
		}
		else{
			results = sellAmount - buyAmount;
//			System.out.println("normal trade");
		}
					
//		System.out.println("We made " +results + " kroner!");
		
		return results;
	}
	@Override
	public Double call() throws Exception {
		// TODO Auto-generated method stub
			double results = 0;
			double tempResults = 0;
			String name = ts.getName();
			ArrayList<NewsTrend> newsList = new ArrayList<>();
			FileInputStream fis = new FileInputStream(new File("C:\\Master\\trendsbystock\\trendsbystock"+period +"min"+tresHold+"\\"+name+"\\newstrends"));
			BufferedInputStream bis = new BufferedInputStream(fis);
			ObjectInputStream ois = new ObjectInputStream(bis);
			newsList = (ArrayList<NewsTrend>) ois.readObject();
//			System.out.println(period);
//			for(int i =0 ; i<newsList.size();i++){
//				System.out.println(newsList.get(i).getName());
//				System.out.println(newsList.get(i).getDirectory());
//			}
//			System.out.println(name);
			for(int i = 0; i<newsList.size();i++){
//				System.out.println(newsList.size());
				String tempName = newsList.get(i).getDirectory().substring(newsList.get(i).getDirectory().length()-6);
				FileInputStream fis2 = new FileInputStream(new File("C:/master/processednewsbystock/"+name+"/" + tempName));
				BufferedInputStream bis2 = new BufferedInputStream(fis2);
				ObjectInputStream ois2 = new ObjectInputStream(bis2);
				News news = (News) ois2.readObject();
				int timeOfDay = Integer.parseInt(news.getDate().substring(news.getDate().length()-6));
				if(true){
					if(timeOfDay<90000){
						continue;
					}
					else if(timeOfDay>173000){
						continue;
					}
				}
				int direction = newsList.get(i).getDirection();
				if(true){
					
					
					if (direction==1){
						double superTemp = buyStocks(newsList.get(i).getName(), ts, period, moneyPerTransaction, news.getDate(), false);
						if (!(superTemp == tempResults)){
							results+=superTemp;
							
						}
						else {
	//						System.out.println("skipped last transaction due to duplicate");
						}
						tempResults= superTemp;
					}
					else if(direction==-1){
						double superTemp = buyStocks(newsList.get(i).getName(), ts, period, moneyPerTransaction, news.getDate(), true);
						if (!(superTemp == tempResults)){
							results+=superTemp;
							
							
						}
						else {
	//						System.out.println("skipped last transaction due to duplicate");
						}
						tempResults= superTemp;
					}
				}
			
		}
			return results;
	}
}
