package testTing;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import stockPrices.TimeSeries;
import trends.ClosestTime;

import newsProcessor.News;

public class TestTrade2 extends Thread{
	
	private TimeSeries timeSeries;
	private String timeOfNews;
	private String parentSymbol;
	private String nameOfNews;

	public String getParentSymbol() {
		return parentSymbol;
	}

	public void setParentSymbol(String parentSymbol) {
		this.parentSymbol = parentSymbol;
	}

	public String getNameOfNews() {
		return nameOfNews;
	}

	public void setNameOfNews(String nameOfNews) {
		this.nameOfNews = nameOfNews;
	}

	public TimeSeries getTimeSeries() {
		return timeSeries;
	}

	public void setTimeSeries(TimeSeries timeSeries) {
		this.timeSeries = timeSeries;
	}

	public String getTimeOfNews() {
		return timeOfNews;
	}

	public void setTimeOfNews(String timeOfNews) {
		this.timeOfNews = timeOfNews;
	}

	public TestTrade2(TimeSeries ts, String time, String parent, String filename){
		setTimeSeries(ts);
		setTimeOfNews(time);
		setParentSymbol(parent);
		setNameOfNews(filename);
	}
	public static void createSalesSeries() throws ClassNotFoundException, IOException{
		
		File root = new File("c:/master/trendsbystock/trendsbystock1min0.5/");
		File[] symbols = root.listFiles();
		File tsDir =new File("c:/master/timeseries/");
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10, TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6, true), new ThreadPoolExecutor.CallerRunsPolicy());
		
		for(int i = 0; i<symbols.length;i++){
			File dir = new File("c:/master/processedNewsbystock/"+symbols[i].getName() + "/");
			
			File[] dirList = dir.listFiles();
			
			FileInputStream fisTs = new FileInputStream(tsDir.getAbsolutePath() + "/" + symbols[i].getName());
			BufferedInputStream bis = new BufferedInputStream(fisTs);
			ObjectInputStream oisTs = new ObjectInputStream(bis);
			
			TimeSeries ts = (TimeSeries)oisTs.readObject();
			String parent = symbols[i].getName();
			
			
			for(int j  = 0 ; j<dirList.length;j++){
				String filename = dirList[j].getName();
				FileInputStream fis = new FileInputStream(dirList[j]);
				ObjectInputStream ois = new ObjectInputStream(fis);
				News news = (News)ois.readObject();
				String time = news.getDate();
				Thread t = new TestTrade2(ts, time, parent, filename);
				exService.submit(t);
			}
			System.out.println("done with " + symbols[i].getName());
		}
		exService.shutdown();
		
	}
	public void run(){
		double[] results = new double[120];
		ClosestTime buyTime = new ClosestTime(timeOfNews, timeSeries);
		int transNum = buyTime.getTransactionID();
		double buyPrice = timeSeries.getPrices().get(transNum);
		
		int investAmount = 100000;
		int buyAmount = (int)(investAmount/buyPrice);
		double invested = buyAmount*buyPrice;
		int startTime = Integer.parseInt(timeOfNews.substring(timeOfNews.length()-6));
		int startDate = timeSeries.getDate().get(transNum);
		for(int i = 1;i<=120;i++ ){
		
			boolean cont = true;
			int stopTime = startTime+(i*100);
			if (stopTime%10000>59 || stopTime%100 == 0){
				stopTime+=40;
			}
			if(stopTime%10000 >5999){
				stopTime+=4000;
			}
			while (true){
				transNum++;
				int newTime = Integer.parseInt(timeSeries.getTime().get(transNum).substring(timeOfNews.length()-6));
				if (newTime >= stopTime){
					break;
				}
				if(timeSeries.getDate().get(transNum)!= startDate){
					break;
				}
				
			}
			double sellPrice = timeSeries.getPrices().get(transNum-1);
			double moneyBack = sellPrice*buyAmount;
			double result = moneyBack-invested;
			results[i-1] = result;
			
		}
		FileOutputStream fos;
		try {
			File dir = new File("c:/master/newscombinedwithtrade/"+parentSymbol + "/");
			if(!dir.exists()){
				dir.mkdir();
			}
			fos = new FileOutputStream("c:/master/newscombinedwithtrade/"+parentSymbol + "/" + nameOfNews);
		
			ObjectOutputStream oos = new ObjectOutputStream(fos);
			oos.writeObject(results);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
}
