package testTing;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import stockPrices.TimeSeries;

public class TestTradeExecutor {
	
	public static void execute() throws IOException, InterruptedException, ExecutionException, ClassNotFoundException{
		double tresHold = 0.5;
		double[] resultsArray = new double[120];
		
		List<Future<Double>> list = Collections.synchronizedList(new ArrayList<Future<Double>>());
		ExecutorService exService = new ThreadPoolExecutor(6, 6, 10, TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(6, true), new ThreadPoolExecutor.CallerRunsPolicy());
		File[] timeSeries = new File("c:/master/trendsbystock/trendsbystock1min1.0/").listFiles();
		ArrayList<TimeSeries> tsList = new ArrayList<>();
		for(int i = 0;i<timeSeries.length;i++){
//		for(int i = 0;i<3;i++){
//			if(!timeSeries[i].getName().equals("AKSO")){
//				continue;
//			}
			File timeseriesFile = new File("c:/master/timeSeries/" + timeSeries[i].getName());
			FileInputStream fis = new FileInputStream(timeseriesFile);
			BufferedInputStream bis = new BufferedInputStream(fis);
			ObjectInputStream ois = new ObjectInputStream(bis);
			TimeSeries ts = (TimeSeries)ois.readObject();
			
			
			tsList.add(ts);
			System.out.println("Read Timeseries for " + ts.getName());
//			results += TestTrade(ts ,tresHold, 100000, periode);
			
		}
		int indexOfList = 0;
		for(int periode=1;periode<=120;periode++){
//			System.out.println("hit kom jeg");
			double results = 0;
			for(int j = 0; j<tsList.size();j++){
//				System.out.println("ogs hit");
				Callable<Double> t = new TestTrade(tsList.get(j), tresHold, 1000000, periode);
				Future<Double> submit = exService.submit(t);
				list.add(submit);
//				System.out.println("TEST");
			}
			
//			System.out.println("test2");
			
//			System.out.println("test3");
			for(int i = indexOfList; i<list.size();i++){
//				System.out.println(list.size());
				results+=list.get(i).get();
//				System.out.println(i);
			}
			resultsArray[periode-1] = results;
			indexOfList = list.size();
			
			System.out.println("Periode: " + periode + " , Results: " + results );
		}
		exService.shutdown();
		while(!exService.awaitTermination(10, TimeUnit.SECONDS)){
			System.out.println("waiting for completion");;
		}
		double bestResults= -1;
		int bestPeriode = -1;
		for(int i = 0; i<resultsArray.length;i++){
			if (resultsArray[i]>bestResults){
				bestResults = resultsArray[i];
				bestPeriode = i+1;
			}
			else if(resultsArray[i]==bestResults){
				System.out.println(i+1 + " and " + bestPeriode + " er like");
				System.out.println("They are both at " + resultsArray[i]);
			}
		}
		System.out.println("beste resultat etter " + bestPeriode + " minutter. Resultat: " + bestResults );
		File makeDir = new File("c:/master/tradingsimulations/PerfectInformation/treshold" + tresHold + "/");
		if(!makeDir.exists()){
			makeDir.mkdir();
		}
		FileOutputStream fos = new FileOutputStream(makeDir.getAbsolutePath()+"/resultsArray");
//		BufferedOutputStream bos = new BufferedOutputStream(fos);
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(resultsArray);
		oos.close();
		
	}

}
