package trends;

import org.apache.commons.math3.stat.regression.SimpleRegression;

import stockPrices.TimeSeries;

public class CheckRegressionTrends {
	
	
	
	public static RegressionObject getTrendRegression(int indexOfTrade, String time, int offset, int dayDiff, boolean afterClosing, String newsDate, int lengthOfTrendInMinutes, TimeSeries ts, String nameOfNews, String symbol){
		
		SimpleRegression sr = new SimpleRegression();
		int savelength = lengthOfTrendInMinutes;
		
		
		int newIndex = indexOfTrade+1;
		
		int intraDayTime = 0;
		int day = Integer.parseInt(time.substring(0,8));
		
		if (day < 20091102){
			return null;
		}
		if(afterClosing){
			intraDayTime = 90000;
		}

		else {
			intraDayTime = Integer.parseInt(time.substring(time.length()-6, time.length())) + offset;
		}
		
		sr.addData(intraDayTime - offset, ts.getPrices().get(indexOfTrade));
		
		if (lengthOfTrendInMinutes>60){
			int hours = lengthOfTrendInMinutes/60;
			int minutes = lengthOfTrendInMinutes%60;
			lengthOfTrendInMinutes=hours*100+minutes;
		}
		int endTime = intraDayTime+lengthOfTrendInMinutes*100;
		if (endTime%100>59 || endTime %100==0){
			endTime+=40;
		}
		if (endTime%10000>5999||endTime%10000==0){
			endTime+=4000;
		}
		
		double prevTime=0;
		if (newIndex==ts.getTime().size()){
			return null;
		}
		
		//If more than one transaction happen in the same period I will average them so the linear regression has equal distance on the x axis.
		int concurrentTransactions = 0;
		double sumPrice = 0;
		int saveTime = 0;
//		System.out.println("test");
		while(Integer.parseInt(ts.getTime().get(newIndex).substring(time.length()-6, time.length())) < (endTime)){
			
			int testTime = Integer.parseInt(ts.getTime().get(newIndex).substring(time.length()-6, time.length()));
			saveTime = testTime;
			if(testTime < prevTime){
				break;
			}
			else if(prevTime==testTime) {
				concurrentTransactions++;
				sumPrice+=ts.getPrices().get(newIndex);
			}
			else {
				if(concurrentTransactions!=0){
					sr.addData(prevTime, sumPrice/concurrentTransactions);
				}
				concurrentTransactions=1;
				sumPrice=ts.getPrices().get(newIndex);
			}
			newIndex++;
			if (newIndex==ts.getTime().size()){
				break;
			}
		}
		sr.addData(saveTime,sumPrice/concurrentTransactions);
		
		
		RegressionObject ro = new RegressionObject(sr, nameOfNews, symbol,savelength);
		return ro;
		
	}

}
