package trends;

import stockPrices.TimeSeries;

//This class checks if the stock price as decreased or increased in a given period after a given time. 

public class CheckTrend {
	
	double change;
	int numOfTransactions;
	int direction;
	double maxTrade;
	double minTrade;
	public double getMinTrade() {
		return minTrade;
	}

	public void setMinTrade(double minTrade) {
		this.minTrade = minTrade;
	}

	String maxTime;
	String minTime;

	public String getMaxTime() {
		return maxTime;
	}

	public void setMaxTime(String maxTime) {
		this.maxTime = maxTime;
	}

	public String getMinTime() {
		return minTime;
	}

	public void setMinTime(String minTime) {
		this.minTime = minTime;
	}

	public double getMaxTrade() {
		return maxTrade;
	}

	public void setMaxTrade(double maxTrade) {
		this.maxTrade = maxTrade;
	}

	public double getChange() {
		return change;
	}

	public void setChange(double change) {
		this.change = change;
	}

	public int getNumOfTransactions() {
		return numOfTransactions;
	}

	public void setNumOfTransactions(int numOfTransactions) {
		this.numOfTransactions = numOfTransactions;
	}

	public int getDirection() {
		return direction;
	}

	public void setDirection(int direction) {
		this.direction = direction;
	}

	public CheckTrend(int index, String time, int lengthOfTrendInMinutes, int offset, int dayDiff, TimeSeries ts, double alphaPercent, double betaPercent, boolean afterClosing, String newsDate) throws InterruptedException{
		
		//Averate price - start price / start price

//		if (Integer.parseInt(newsDate.substring(newsDate.length()-6))<90000 || Integer.parseInt(newsDate.substring(newsDate.length()-6))>173000){
//			setDirection(-2);
//			return;
//		}
		double startPrice = ts.getPrices().get(index);
		
		double avgPrice = 0.0;
		double sumPrice = 0.0;

		int transactions = 0;
		int newIndex = index+1;
		int intraDayTime = 0;
		int day = Integer.parseInt(time.substring(0,8));
		if (day < 20091102){
			return;
		}
		if(afterClosing){
			intraDayTime = 90000;
		}

		else {
			intraDayTime = Integer.parseInt(time.substring(time.length()-6, time.length())) + offset;
		}
		
		double maxPrice = startPrice;
		double minPrice = startPrice;
		String tempMax = "";
		String tempMin = "";
		
		double prevTime=0;
//		System.out.println( Integer.parseInt(time.substring(time.length()-6, time.length())));
//		System.out.println(offset);
//		System.out.println(intraDayTime);
		if (lengthOfTrendInMinutes>60){
			int hours = lengthOfTrendInMinutes/60;
			int minutes = lengthOfTrendInMinutes%60;
			lengthOfTrendInMinutes=hours*100+minutes;
		}
		int endTime = intraDayTime+lengthOfTrendInMinutes*100;
		if (endTime%100>59 || endTime %100==0){
			endTime+=40;
		}
		if (endTime%10000>5999||endTime%10000==0){
			endTime+=4000;
		}
		
//		System.out.println(endTime);
//		System.out.println(ts.getDate().get(newIndex));
		if (newIndex==ts.getTime().size()){
			return;
		}
		while(Integer.parseInt(ts.getTime().get(newIndex).substring(time.length()-6, time.length())) < (endTime)){
			
			int testTime = Integer.parseInt(ts.getTime().get(newIndex).substring(time.length()-6, time.length()));
			if(testTime<prevTime){
				break;
			}
			else {
				prevTime=testTime;
			}
			
			double currentPrice = ts.getPrices().get(newIndex);
			sumPrice+=currentPrice;
			transactions++;

			if(currentPrice > maxPrice){
				maxPrice = currentPrice;
				tempMax = ts.getTime().get(newIndex);
				
			}
			if(currentPrice < minPrice){
				minPrice = currentPrice;
				tempMin = ts.getTime().get(newIndex);
			}
			newIndex++;
			if (newIndex==ts.getTime().size()){
				break;
			}
		}
		avgPrice = sumPrice/transactions;
		
//		if(transactions == 0){
//			System.out.println("LOOOOOL");
//			Thread.sleep(1000);
//		}
		
		
		double trend = (avgPrice - startPrice) / startPrice;
//		System.out.println("trend: " + trend);
	
		double maxTrend = (maxPrice - startPrice) / startPrice;
		double minTrend = (minPrice - startPrice) / startPrice;
		
		double alpha = alphaPercent/100;
		double beta = betaPercent/100;
//		System.out.println(alpha);
//		System.out.println(maxTrend);
//		System.out.println(minTrend);
//		
		int trendDirection = 0;
		if ((trend > alpha) && (maxTrend > beta)){
			trendDirection = 1;
		}
		else if ((trend < -1*alpha) && (minTrend < -1*beta )){
			trendDirection = -1;
		}
		else {
			trendDirection = 0;
		}
		setDirection(trendDirection);
		setNumOfTransactions(transactions);
		setChange(trend);
		setMaxTrade(maxTrend);
		setMinTrade(minTrend);
		setMaxTime(tempMax);
		setMinTime(tempMin);
	}
}
