package trends;

import java.io.File;
import java.io.IOException;
import java.util.Date;

import newsProcessor.News;


import stockPrices.TimeSeries;

public class Main {
	
	public static void main(String[] args) throws ClassNotFoundException, IOException, InterruptedException {
		
		long startTime = System.currentTimeMillis();
		Date date = new Date ();
		date.setTime((long)(startTime));
		System.out.println("Starting at time: " + date.toString());
		
		//Insert tickername, time of news and length of period to check for trends
		String stock = "AKER";
		String time = "20120130T123900";
		int period = 15;
		
		File timeSeriesFile = new File("c:/master/timeseries/" + stock);
		TimeSeries ts = ReadTimeSeries.readTimeSeries(timeSeriesFile);
		
		long currentTime = System.currentTimeMillis();
		System.out.println("Read File in : " + (currentTime-startTime)/1000 + " seconds");
		
		ClosestTime ct = new ClosestTime(time, ts);
//		System.out.println("offset: " + ct.getOffset());
//		System.out.println("dayDiff: " + ct.getDayDiff());
//		System.out.println("Closest time: " + ct.getPrevTime());
//		System.out.println("Index: " + ct.getTransactionID());
//		System.out.println("Price: " + ts.getPrices().get(ct.getTransactionID()));
//		
		System.out.println("Found previous transaction in: " + (System.currentTimeMillis()-currentTime)/1000 + " seconds");
		currentTime = System.currentTimeMillis();
		
		RegressionObject ro = CheckRegressionTrends.getTrendRegression(ct.getTransactionID(), ts.getTime().get(ct.getTransactionID()), ct.getOffset(), ct.getDayDiff(), ct.isAfterClosing, "", period, ts, "test", "test");
		
		System.out.println(ro.getSr().getMeanSquareError());
		System.out.println(ro.getSr().getSignificance());
		System.out.println(ro.getSr().getSlope());
		System.out.println(ro.getSr().getSlopeStdErr());
		
//		System.out.println("Date: " + time);
//		System.out.println("PrevTime: " + ct.getPrevTime());
//		System.out.println(ct.getOffset());
//		System.out.println(ct.getDayDiff());
		
		
//		CheckTrend cTrend = new CheckTrend(ct.getTransactionID(),ts.getTime().get(ct.getTransactionID()), period , ct.getOffset() , ct.getDayDiff(), ts,  0.5, 0.3, ct.isAfterClosing, "");
//		
//		System.out.println("Direction: " + cTrend.getDirection());
//		System.out.println("Change: " + cTrend.getChange());
//		System.out.println("Number of transations: " + cTrend.getNumOfTransactions());
//		
//		System.out.println("Max: " + cTrend.getMaxTime());
//		System.out.println("Max: " +cTrend.getMaxTrade());
//		System.out.println("Min: " + cTrend.getMinTime());
//		System.out.println("Min: " + cTrend.getMinTrade());
//		
//		System.out.println("done in: " + (System.currentTimeMillis()-startTime)/1000 + " seconds");
	}
	
	

}
